
#include <Wt/WLabel> //WLabel
#include <Wt/WGroupBox> //WGroupBox
#include <Wt/WVBoxLayout> //WVBoxLayout
#include <QThread> //QThread
#include <Wt/WTable> //WTable
#include <Wt/WPushButton> //WPushButton
#include <QStringList> //QStringList
#include <QtDebug> //qDebug
#include <Wt/WScrollArea> //WScrollArea
#include <Wt/WApplication> //WApplication


#include "SingleDomainManageWidget.h"

/*!
  *@brief 默认构造函数。
  */
SingleDomainManageWidget::SingleDomainManageWidget()
{
    qDebug() << __FILE__ << __LINE__ << __func__ << QThread::currentThreadId() ; //Debug.


    DomainNameLabel=new WLabel(); //用来显示域名的标签。
    ResolveManageLabel=new WLabel("resolve management"); //“解析管理”。

    DomainNameLayout=new WHBoxLayout(); //创建布局器。
    DomainNameLayout->addWidget(DomainNameLabel); //添加到布局器中。
    DomainNameLayout->addWidget(ResolveManageLabel,1,AlignLeft); //添加到布局器中。


    //各个记录的分组框：



    TxtGroupBox=new WGroupBox("TXT Record"); //文本记录的分组框。



    //将各个分组框添加到布局器中：
    SingleDomainManageLayout=new WVBoxLayout(); //创建布局管理器。
    SingleDomainManageLayout->addLayout(DomainNameLayout); //域名的标签及解释标签。



    TxtScrollArea=new WScrollArea; //文本记录的滚动区域。
    TxtScrollArea->setWidget(TxtGroupBox); //设置滚动区域。
    SingleDomainManageLayout->addWidget(TxtScrollArea); //文本记录的分组框。



    setLayout(SingleDomainManageLayout); //设置布局管理器。



    //文本记录：
    TxtNewPushButton=new WPushButton("New"); //“新增”按钮。
    TxtNewPushButton->clicked().connect(this,&SingleDomainManageWidget::EmitASignal); //Debug.
    TxtTable=new WTable; //创建一个表格。
    TxtTable->setStyleClass("RecordTable"); //设置ＣＳＳ类。
    TxtTable->setHeaderCount(1); //表头行数。
    TxtTable->elementAt(0,0)->addWidget(new WLabel("Hostname")); //添加“主机名”表头。
    TxtTable->elementAt(0,1)->addWidget(new WLabel("Text")); //添加“文本内容”表头。
    TxtTable->elementAt(0,2)->addWidget(new WLabel("TTL")); //添加“生存时间”表头。
    TxtTable->elementAt(0,3)->addWidget(new WLabel("Operation")); //添加“操作”表头。
    TxtLayout=new WVBoxLayout; //文本记录的布局器。
    TxtLayout->addWidget(TxtNewPushButton); //将新增按钮添加到布局中。
    TxtLayout->addWidget(TxtTable,1); //将文本记录表格添加到布局中。
    TxtGroupBox->setLayout(TxtLayout); //设置布局器。

    HostProcessFinished.connect(this,&SingleDomainManageWidget::ParseHostResult); //host命令的进程结束之后，分析其结果。

    connect(&HostProcess,SIGNAL(finished(int)),this,SLOT(ShouldParseHostResult())); //host进程运行完毕之后，分析其结果。
    connect(this,SIGNAL(ASignal()),this,SLOT(HostProcessFinishedA())); //Debug.
} //SingleDomainManageWidget::SingleDomainManageWidget()

/*!
  *@brief 设置要管理的域名。
  *@param DomainName2Set 要设置的域名。
  *
  *调用host命令查询出该区全部的记录，显示出来。
  */
void SingleDomainManageWidget::SetDomainName(WString DomainName2Set)
{
    DomainName=DomainName2Set; //记录域名。

    DomainNameLabel->setText(DomainName); //设置域名显示文字标签的文字。


    QString HostCommand="host"; //host命令的可执行程序。

    HostProcess.start(HostCommand); //启动host命令。

//    HostProcess.waitForFinished(); //等待进程结束。

//    HostProcessFinished.emit(); //发射信号，host命令结束咯。

    return;
} //void SingleDomainManageWidget::SetDomainName(WString DomainName2Set)


/*!
  *@brief 分析host命令输出的结果。
  */
void SingleDomainManageWidget::ParseHostResult()
{
    QString CurHostName=""; //当前域名。

    qDebug() << __FILE__ << __LINE__ << __func__ << QThread::currentThreadId() ; //Debug.
    TxtTable->elementAt(1,0)->addWidget(new WLabel(CurHostName.toStdString())); //插入当前域名。



    return;
} //void SingleDomainManageWidget::ParseHostResult()


/*!
  *@brief 启动host命令。
  */
void SingleDomainManageWidget::RunHost()
{

    return;
} //void SingleDomainManageWidget::RunHost()

void SingleDomainManageWidget::HostProcessFinishedA() //!<Debug.
{
    std::cout << __FILE__ << "," << __LINE__ << "," << __func__ << std::endl; //Debug.

    SetDomainName("a"); //Debug.

    return;
} //void SingleDomainManageWidget::HostProcessFinishedA()

void SingleDomainManageWidget::EmitASignal() //!<Debug.
{
    Q_EMIT ASignal(); //Debug.

    return;
} //void SingleDomainManageWidget::EmitASignal()

/*!
  *@brief 告诉wt要发送信号使程序开始分析host命令输出的结果。
  */
void SingleDomainManageWidget::ShouldParseHostResult()
{
    qDebug()  << __FILE__ << __LINE__ << __func__ ;  //Debug.

    HostProcessFinished.emit(); //发射信号。

    return;
} //void SingleDomainManageWidget::ShouldParseHostResult()
